package net.alpenblock.bungeeperms.config;

public class YamlConfigurationOptions extends FileConfigurationOptions
{

    private int indent = 2;

    protected YamlConfigurationOptions(YamlConfiguration configuration)
    {
        super(configuration);
    }

    @Override
    public YamlConfiguration configuration()
    {
        return (YamlConfiguration) super.configuration();
    }

    @Override
    public YamlConfigurationOptions copyDefaults(boolean value)
    {
        super.copyDefaults(value);
        return this;
    }

    @Override
    public YamlConfigurationOptions pathSeparator(char value)
    {
        super.pathSeparator(value);
        return this;
    }

    @Override
    public YamlConfigurationOptions header(String value)
    {
        super.header(value);
        return this;
    }

    @Override
    public YamlConfigurationOptions copyHeader(boolean value)
    {
        super.copyHeader(value);
        return this;
    }

    public int indent()
    {
        return indent;
    }

    public YamlConfigurationOptions indent(int value)
    {

        this.indent = value;
        return this;
    }
}
